
require 'java'

import 'gate.Gate'
import 'gate.Factory'
import 'at.ofai.gate.scripting.LRScriptConsole'
import 'java.net.URL'
import 'java.util.HashMap'

def getNamed(name,classname)
  LRScriptConsole.getNamed(name,classname)
end 

def getCorpus(name)
  LRScriptConsole.getCorpus(name)
end

def getDocument(name)
  LRScriptConsole.getDocument(name)
end

def getController(name)
  LRScriptConsole.getController(name)
end

def getDataStore(name)
  dsReg = Gate.getDataStoreRegister()
  i = dsReg.iterator()
  while i.hasNext()
    ds = i.next()
    if ds.getName().index(name)
      return ds
    end
  end
end

def openDataStore(dir)
  Factory.openDataStore("gate.persist.SerialDataStore",dir)
end

def newCorpus(name)
  Factory.newCorpus(name)
end

def newDocument(name)
  parms = Factory.newFeatureMap
  feats = Factory.newFeatureMap
  d = Factory.createResource("gate.corpora.DocumentImpl",parms,feats,name)
end 

def loadDocument(file)
  u = java.net.URL.new("file://#{file}")
  Factory.newDocument(u)
end

def showMethods(obj)
  obj.methods.sort.join(", ")
end

def exportCorpus(corpusname,dirpath)
  c = getCorpus(corpusname)
  c.each do |d|
    text = d.toXml()
    name = d.getName()
    Factory.deleteResource(d)
    if(dirpath)
      path = dirpath + "/" + name
    else
      path = name
    end
    path = path + ".xml"
    file   = File.open(path, File::WRONLY|File::CREAT) 
    file.write(text)
    file.close()
  end
end

puts "init.rb loaded"
