/*
 *  LRScriptConsoleJavascript.java
 *
 *  Copyright (c) 2007-, 
 *    Austrian Research Institute for Aritificial Intelligence (OFAI)
 *
 *  Johann Petrak, 2007-06-23
 *
 *  $Id: LRScriptConsoleJavascript.java  $
 *
 */

package at.ofai.gate.scripting;

import java.util.*;
import javax.script.*;
import java.io.*;

import gate.*;
import gate.creole.ResourceInstantiationException;

public class LRScriptConsoleJavascript extends LRScriptConsole {

  /** Initialise this resource, and return it. */
  @Override
  public Resource init() throws ResourceInstantiationException {
    
    // try to instantiate a javascript scripting engine.
    // Java 6 and probably beyond come with the Rhino scripting engine,
    // so this should always work
    try {
      scriptLanguage = "javascript";
      initEngine();
      File initFile = new File(initDir,"init.js"); 
      scriptEngine.eval(new FileReader(initFile));
    }
    catch(Exception e) {
      throw new ResourceInstantiationException(e);
    }

    return this;
  } // init()


}