/*
 *  LRScriptConsoleVR.java
 *
 *  Copyright (c) 2007-, 
 *    Austrian Research Institute for Aritificial Intelligence (OFAI)
 *
 *  Johann Petrak, 2007-06-23
 *
 *  $Id: LRScriptConsoleVR.java  $
 *
 */
package at.ofai.gate.scripting;

import java.awt.*;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileWriter;
import java.io.FileReader;
import java.io.IOException;

import javax.swing.*;
import javax.script.*;

import gate.Resource;
import gate.LanguageResource;
import gate.creole.AbstractVisualResource;

public class LRScriptConsoleVR extends AbstractVisualResource
                           implements ActionListener{

  @Override
  public Resource init(){
    initComponents();
    consoleLog = new StringBuffer();
    return this;
  }
  private StringBuffer consoleLog;
  private LRScriptConsole lr;
  private LanguageResource theLR;
  
  @Override 
  public void setTarget(Object target) {
    if ( ! (target instanceof LRScriptConsole) || 
         target.getClass() == LRScriptConsole.class )
    {
      throw new IllegalArgumentException(
        "The LRScriptConsoleVisual can only be used with  LRs!\n" +
        target.getClass().toString() + " is not one of them!"
      );
    }
    
    this.lr = (LRScriptConsole)target;
    scriptEngine = lr.getScriptEngine();
    ScriptEngineFactory sef = scriptEngine.getFactory();
    String enginedata = 
      "Engine: "+sef.getEngineName()+
      " Version: "+sef.getEngineVersion()+
      " Language: "+sef.getLanguageName()+
      " Version: "+sef.getLanguageVersion();
    jLabel2.setText(enginedata);
    jLabel1.setText("OFAI Script Console: "+lr.getScriptLanguage() );
    jTextArea1.append(((LRScriptConsole)target).getHelpInfo());
  }

  public void actionPerformed(java.awt.event.ActionEvent event) {
    // TODO: what is this good for?
  }
  
  private ScriptEngine scriptEngine;
  
  private void initComponents() {
    jPanelMain = new javax.swing.JPanel();
    jSplitPane1 = new javax.swing.JSplitPane();
    jScrollPane2 = new javax.swing.JScrollPane();
    jTextArea2 = new javax.swing.JTextArea();
    jScrollPane3 = new javax.swing.JScrollPane();
    jTextArea1 = new javax.swing.JTextArea();
    jButton1 = new javax.swing.JButton();
    jButton2 = new javax.swing.JButton();
    jButton3 = new javax.swing.JButton();
    jButton4 = new javax.swing.JButton();
    jLabel1 = new javax.swing.JLabel();
    jLabel2 = new javax.swing.JLabel();

    jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
    jSplitPane1.setResizeWeight(1.0);
    jScrollPane2.setBorder(javax.swing.BorderFactory.createTitledBorder("Command"));
    jTextArea1.setLineWrap(true);
    jTextArea2.setColumns(20);
    jTextArea2.setRows(5);
    jScrollPane2.setViewportView(jTextArea2);

    jSplitPane1.setRightComponent(jScrollPane2);

    jScrollPane3.setBorder(javax.swing.BorderFactory.createTitledBorder("Log"));
    jTextArea1.setColumns(20);
    jTextArea1.setEditable(false);
    jTextArea1.setRows(5);
    jScrollPane3.setViewportView(jTextArea1);

    jSplitPane1.setTopComponent(jScrollPane3);

    jButton1.setText("Run");
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton1ActionPerformed(evt);
      }
    });

    jButton2.setText("Save");
    jButton2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton2ActionPerformed(evt);
      }
    });

    jButton3.setText("Clear");
    jButton3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton3ActionPerformed(evt);
      }
    });

    jButton4.setText("Load");
    jButton4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton4ActionPerformed(evt);
      }
    });
   
    jLabel1.setText("Groovy Scripting Console");

    jLabel2.setText("Engine Verions: 2.0");

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 315, Short.MAX_VALUE)
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
            .addComponent(jButton1)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jButton2)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jButton4)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 223, Short.MAX_VALUE)
            .addComponent(jButton3))
          .addComponent(jLabel1)
          .addComponent(jLabel2))
        .addContainerGap()
        )
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addContainerGap()
        .addComponent(jLabel1)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jLabel2)
        .addGap(19, 19, 19)
        .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 420, Short.MAX_VALUE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jButton1)
          .addComponent(jButton2)
          .addComponent(jButton3)
          .addComponent(jButton4))
        .addContainerGap()
        )
    );
    //add(jPanelMain);
  }
  
  private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {                                         
    runCmd();
  }                                        
  private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {
    File saveFile;
            System.out.println("current dir is "+currentFileChooserDir);
    JFileChooser chooser = new JFileChooser(currentFileChooserDir);
    int returnVal = chooser.showOpenDialog(this);
    if(returnVal == JFileChooser.APPROVE_OPTION) {
      saveFile = chooser.getSelectedFile();
      if(saveFile != null && !saveFile.getName().equals("")) {
        try {
          FileWriter fileWriter = new FileWriter(saveFile);
          fileWriter.write(consoleLog.toString());
          fileWriter.close();
          currentFileChooserDir = new File(saveFile.getParent());
            System.out.println("current dir is "+currentFileChooserDir);
          jTextArea1.append("=== current log saved to file "+saveFile.getName()+"\n");
        } catch (IOException e) {
          jTextArea1.append("=== error saving file: "+e+"\n");
        }
      } else {
        jTextArea1.append("=== not a valid file for saving\n");
      }
    } else {
      jTextArea1.append("=== nothing saved\n");
    }
  }                                        
 private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {                                         
    jTextArea1.setText("=== log cleared\n\n");
    consoleLog.setLength(0);
  }                                        
  private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {                                         
    File loadFile;
            System.out.println("current dir is "+currentFileChooserDir);
    JFileChooser chooser = new JFileChooser(currentFileChooserDir);
    int returnVal = chooser.showOpenDialog(this);
    if(returnVal == JFileChooser.APPROVE_OPTION) {
      loadFile = chooser.getSelectedFile();
      if(loadFile != null && !loadFile.getName().equals("")) {
        try {
          FileReader fileReader = new FileReader(loadFile);
          try {
            scriptEngine.eval(fileReader);
            currentFileChooserDir = new File(loadFile.getParent());
            System.out.println("current dir is "+currentFileChooserDir);
          } catch (Exception e) {
            e.printStackTrace();
            jTextArea1.append(e.toString()+"\n\n");
          }
          jTextArea1.append("=== read and executed "+loadFile.getName()+"\n");
        } catch (IOException e) {
          jTextArea1.append("=== error loading file: "+e+"\n");
        }
      } else {
        jTextArea1.append("=== not a valid file for loading\n");
      }
    } else {
      jTextArea1.append("=== nothing saved\n");
    }
  }                                        
  
  /**
   * @param args the command line arguments
   */
  public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
      public void run() {
        new Frame().setVisible(true);
      }
    });
  }
  private void runCmd() {
    String command = jTextArea2.getText();
    boolean shortenOutput = false;
    if(command.equals("")) {
      return;
    }
    if(command.startsWith("^")) {
      command = command.substring(1);
      shortenOutput = true;
    }
    jTextArea1.append("<-- "+command+"\n");
    Object value = null;
    jTextArea1.append("--> ");
    try {
      value = scriptEngine.eval(command);
      if(value == null) {
        value = new String("[null]");
      }
      String valueAsString = value.toString();
      if(shortenOutput) {
        Integer l = valueAsString.length();
        if(l > 80) {
          valueAsString = valueAsString.substring(0,39)+
            " ...("+(l-80)+" more)... "+
            valueAsString.substring(l-40,l-1);
        }
      }
      jTextArea1.append(valueAsString+"\n\n");
      consoleLog.append(command);
      consoleLog.append("\n");
    } catch (Exception e) {
      e.printStackTrace();
      jTextArea1.append(e.toString()+"\n\n");
    }
    jTextArea2.setText("");
  }
  private File currentFileChooserDir;
  
  private javax.swing.JPanel  jPanelMain;
  private javax.swing.JButton jButton1;
  private javax.swing.JButton jButton2;
  private javax.swing.JButton jButton3;
  private javax.swing.JButton jButton4;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JLabel jLabel2;
  private javax.swing.JScrollPane jScrollPane2;
  private javax.swing.JScrollPane jScrollPane3;
  private javax.swing.JSplitPane jSplitPane1;
  private javax.swing.JTextArea jTextArea1;
  private javax.swing.JTextArea jTextArea2;
}
